/***************************************************************************************
 * @file     va108xx_hal.h
 * @version  V0.1
 * @date     06 February 2019
 *
 * @note
 * VORAGO Technologies
 *
 * @note
 * Copyright (c) 2013-2019 VORAGO Technologies.
 *
 * @par
 * BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND BY
 * ALL THE TERMS AND CONDITIONS OF THE VORAGO TECHNOLOGIES END USER LICENSE AGREEMENT.
 * THIS SOFTWARE IS PROVIDED "AS IS". NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. VORAGO TECHNOLOGIES
 * SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
 * DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 ****************************************************************************************/
 
#ifndef __VA108XX_HAL_H
#define __VA108XX_HAL_H

/*****************************************************************************/ 
/* Include files                                                             */ 
/*****************************************************************************/

#include <stdio.h>
#include <stdint.h>
#include <stdbool.h>
#include "va108xx.h"

/*****************************************************************************/ 
/* Global pre-processor symbols/macros ('#define')                           */ 
/*****************************************************************************/

/** NULL pointer */
#ifndef NULL
#define NULL ( (void *) 0)
#endif
    
#define HAL_NVIC_MAX_PRIO  (15)  // highest priority number (lowest priority)

/*****************************************************************************/
/* Global type definitions ('typedef')                                       */ 
/*****************************************************************************/

/** HAL status (driver call return value) */
typedef enum
{
  hal_status_ok = 0,
  hal_status_initError,
  hal_status_badParam,
  hal_status_notInitialized,
  hal_status_badPeriphID,
  hal_status_timeout,
  hal_status_rxError,
  hal_status_txError,
  hal_status_bufEmpty,
  hal_status_bufFull,
  hal_status_nak,
  hal_status_notImplemented
} hal_status_t;

/*****************************************************************************/
/* Global variable declarations ('extern', definition in C source)           */
/*****************************************************************************/

/*****************************************************************************/ 
/* Global function prototypes ('extern', definition in C source)             */ 
/*****************************************************************************/

/*****************************************************************************/ 
/* End of file                                                               */ 
/*****************************************************************************/
#endif /* __VA108XX_HAL_H */
